#! /bin/sh
# Cut off a long line into several lines with a backslash at the end.
# This script reads from standard input, so pipe something to it.

if test $# -eq 1; then
    LINELENGTH=$1
else
    LINELENGTH=65
fi

while read LINE; do
    if test $(echo "$LINE" | wc -L) -le $LINELENGTH; then
        # If line is not too long, simply echo it.
        echo "$LINE"
    else
        # How many lines are there after folding?
        LINES=$(echo "$LINE" | fold --width $LINELENGTH --spaces | sed "s/$/\\\/" | wc -l)
        BACKSLASH_LINES=$(echo "scale=10; $LINES-1" | bc -l)
        # Add a backslash to all but the last line.
        echo "$LINE" | fold --width $LINELENGTH --spaces | sed "s/$/\\\/" | head -$BACKSLASH_LINES
        echo "$LINE" | fold --width $LINELENGTH --spaces | tail -1
    fi
done
